(function ($, window, document) {
  'use strict';

  var $dialog, scroll_div;

  function random(min, max) { return Math.round(Math.random() * (max - min) + min); }

  function show_message() {
    var $msg = joinchat_obj.$('.joinchat__message.joinchat--hidden:first()');
    if ($msg.length == 0) return;
    $dialog.append('<div class="joinchat__message joinchat__message--loading"></div>');
    scroll_div.scrollTop = scroll_div.scrollHeight;
    setTimeout(function () {
      joinchat_obj.$('.joinchat__message--loading').remove();
      $msg.removeClass('joinchat--hidden');
      scroll_div.scrollTop = scroll_div.scrollHeight;
      setTimeout(show_message, random(400, 600));
    }, random(600, 1400));
  }

  function add_iframe($wrap, src, extra) {
    $wrap.css('padding-top', $wrap.data('height') || null);
    $wrap.html('<iframe src="' + src + '" frameborder="0"' + (extra || '') + '></iframe>');
  }

  function load_iframe() {
    add_iframe($(this), $(this).data('src'));
  }

  function load_calendly() {
    Calendly.initInlineWidget({ url: $(this).data('url'), parentElement: this });
  }

  function load_video() {
    var $wrap = $(this);
    if (!$wrap.is(':empty')) return;
    var src = $wrap.data('service') == 'vimeo'
      ? 'https://player.vimeo.com/video/' + $wrap.data('id') + '?autoplay=1&loop=1&controls=0&dnt=1'
      : 'https://www.youtube-nocookie.com/embed/' + $wrap.data('id') + '?autoplay=1&rel=0&controls=0';
    add_iframe($wrap, src, ' allow="autoplay;encrypted-media;picture-in-picture"');
  }

  function joinchat_cta_extras() {
    // Load video on click
    joinchat_obj.$('.joinchat__box__content').on('click', '.joinchat__video', load_video);

    // Dialog mode (multiple messages)
    $dialog = joinchat_obj.$('.joinchat__dialog');
    scroll_div = joinchat_obj.$('.joinchat__box__scroll').get(0);
    if ($dialog.length && !window.matchMedia('prefers-reduced-motion').matches) {
      joinchat_obj.$('.joinchat__message').addClass('joinchat--hidden');
      $(document).one('joinchat:show', show_message);
    }

    // Load iframes on chat dialog show
    $(document).on('joinchat:show', function () { joinchat_obj.$('.joinchat__iframe').each(load_iframe); });
    $(document).one('joinchat:show', function () { joinchat_obj.$('.calendly-inline-widget').each(load_calendly); });

    // Unload iframes on chat dialog hide
    $(document).on('joinchat:hide', function () { joinchat_obj.$('.joinchat__iframe, .joinchat__video').empty(); });
  }

  if (window.joinchat_obj && !!joinchat_obj.is_ready) joinchat_cta_extras();
  else $(document).one('joinchat:start', joinchat_cta_extras);

})(jQuery, window, document);
